<?php

namespace Picea;

trait EventTrait
{
    protected $_eventTraitMethod = "execute";

    public array $_eventList = [];

    protected array $_returnList = [];

    public function eventRegister(object $event) : void 
    {
        $this->_eventList[] = $event;
    }
    
    public function eventFromType(string $type) : array 
    {
        return array_filter($this->_eventList, fn($ev) => $ev instanceof $type);
    }
    
    public function eventExecute(string $type, ...$arguments) : void 
    {
        foreach($this->eventFromType($type) as $event) {
            $this->_returnList[$event::class][] = call_user_func_array([ $event, $this->_eventTraitMethod ], $arguments);
        }
    }
}