<?php

namespace Picea\Extension;

use Picea\Compiler\Context;

class PrintExtension implements Extension {

    public array $token = [ "echo", "echo.raw", "print",  "print.raw", "printf", "printf.raw" ];
    
    public int $flag = \ENT_QUOTES;

    public string $encoding;

    public bool $doubleEncode = true;

    public function __construct() {
        $this->encoding = ini_get("default_charset");
    }

    public function parse(\Picea\Compiler\Context &$context, ?string $arguments, string $token) : string
    {
        switch($token) {
            case 'echo':
            case 'print':
                return "<?php echo htmlspecialchars((string) $arguments, {$this->flag}, '{$this->encoding}', " . ($this->doubleEncode ? "true" : "false") . ") ?>";

            case 'echo.raw':
            case "print.raw":
                return "<?php echo $arguments ?>";

            case 'printf':
                return "<?php echo htmlspecialchars(sprintf((string) $arguments), {$this->flag}, '{$this->encoding}', " . ($this->doubleEncode ? "true" : "false") . ") ?>";

            case 'printf.raw':
                return "<?php printf((string) $arguments) ?>";
        }
    }
    
}
